## ultimatepp-ultimatepp.zip

=== Makefile ===
UPPDIR1 = ./uppsrc/
UPPDIR2 = /home/cxl/.config/u++/umk/UppHub/gdal/
UPPDIR3 = /home/cxl/.config/u++/umk/UppHub/eigen/

UPPOUT = .cache/upp.out/
CINC   =  -I$(UPPDIR1) -I$(UPPDIR2) -I$(UPPDIR3) `pkg-config --cflags libpng` `pkg-config --cflags freetype2` `pkg-config --cflags fontconfig` `pkg-config --cflags x11` `pkg-config --cflags xcb` `pkg-config --cflags expat` `pkg-config --cflags xinerama` `pkg-config --cflags xrender` `pkg-config --cflags xft` `pkg-config --cflags xdmcp` `pkg-config --cflags xext` `pkg-config --cflags gtk+-3.0` `pkg-config --cflags libnotify` -I./ -I$(UPPOUT)
Macro  =  -DflagGUI -DflagGCC -DflagSHARED -DflagPOSIX -DflagLINUX
CXX = c++
LINKER = $(CXX)
CFLAGS = -O3 -ffunction-sections -fdata-sections 
CXXFLAGS = -O3 -ffunction-sections -fdata-sections  -std=c++17
LDFLAGS = -Wl,--gc-sections $(LINKOPTIONS)
LIBPATH =
AR = ar -sr

OutDir_ide = $(UPPOUT)ide/GCC-Gcc-Gui-Linux-Main-Posix-Shared/
Macro_ide = $(Macro) -DflagMAIN
OutDir_ide_Common = $(UPPOUT)ide/Common/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Common = $(Macro)
OutDir_ide_Core = $(UPPOUT)ide/Core/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Core = $(Macro)
OutDir_ide_LayDes = $(UPPOUT)ide/LayDes/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_LayDes = $(Macro)
OutDir_ide_Builders = $(UPPOUT)ide/Builders/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Builders = $(Macro)
OutDir_ide_Debuggers = $(UPPOUT)ide/Debuggers/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Debuggers = $(Macro)
OutDir_ide_Browser = $(UPPOUT)ide/Browser/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Browser = $(Macro)
OutDir_CodeEditor = $(UPPOUT)CodeEditor/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_CodeEditor = $(Macro)
OutDir_CtrlLib = $(UPPOUT)CtrlLib/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_CtrlLib = $(Macro)
OutDir_plugin_bz2 = $(UPPOUT)plugin/bz2/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_bz2 = $(Macro)
OutDir_HexView = $(UPPOUT)HexView/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_HexView = $(Macro)
OutDir_TextDiffCtrl = $(UPPOUT)TextDiffCtrl/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_TextDiffCtrl = $(Macro)
OutDir_TabBar = $(UPPOUT)TabBar/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_TabBar = $(Macro)
OutDir_ide_Designers = $(UPPOUT)ide/Designers/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Designers = $(Macro)
OutDir_ide_Android = $(UPPOUT)ide/Android/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Android = $(Macro)
OutDir_ide_Java = $(UPPOUT)ide/Java/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_Java = $(Macro)
OutDir_ide_MacroManager = $(UPPOUT)ide/MacroManager/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_MacroManager = $(Macro)
OutDir_Report = $(UPPOUT)Report/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Report = $(Macro)
OutDir_Core_SSL = $(UPPOUT)Core/SSL/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Core_SSL = $(Macro)
OutDir_plugin_md = $(UPPOUT)plugin/md/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_md = $(Macro)
OutDir_ide_clang = $(UPPOUT)ide/clang/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_clang = $(Macro)
OutDir_Esc = $(UPPOUT)Esc/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Esc = $(Macro)
OutDir_Core = $(UPPOUT)Core/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Core = $(Macro)
OutDir_plugin_lzma = $(UPPOUT)plugin/lzma/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_lzma = $(Macro)
OutDir_plugin_lz4 = $(UPPOUT)plugin/lz4/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_lz4 = $(Macro)
OutDir_plugin_zstd = $(UPPOUT)plugin/zstd/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_zstd = $(Macro)
OutDir_RichEdit = $(UPPOUT)RichEdit/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_RichEdit = $(Macro)
OutDir_plugin_png = $(UPPOUT)plugin/png/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_png = $(Macro)
OutDir_Draw = $(UPPOUT)Draw/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Draw = $(Macro)
OutDir_PdfDraw = $(UPPOUT)PdfDraw/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_PdfDraw = $(Macro)
OutDir_Painter = $(UPPOUT)Painter/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_Painter = $(Macro)
OutDir_plugin_pcre = $(UPPOUT)plugin/pcre/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_pcre = $(Macro)
OutDir_CtrlCore = $(UPPOUT)CtrlCore/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_CtrlCore = $(Macro)
OutDir_plugin_bmp = $(UPPOUT)plugin/bmp/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_bmp = $(Macro)
OutDir_RichText = $(UPPOUT)RichText/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_RichText = $(Macro)
OutDir_ide_IconDes = $(UPPOUT)ide/IconDes/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_ide_IconDes = $(Macro)
OutDir_plugin_gif = $(UPPOUT)plugin/gif/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_gif = $(Macro)
OutDir_plugin_jpg = $(UPPOUT)plugin/jpg/GCC-Gcc-Gui-Linux-Posix-Shared/
Macro_plugin_jpg = $(Macro)

OutDir = $(OutDir_ide)
OutFile = ./ide

.PHONY: all
all: prepare $(OutFile)

.PHONY: build_info
build_info:
	(date '+#define bmYEAR    %y%n#define bmMONTH   %m%n#define bmDAY     %d%n#define bmHOUR    %H%n#define bmMINUTE  %M%n#define bmSECOND  %S%n#define bmTIME    Time( %y, %m, %d, %H, %M, %S )' | sed 's| 0\([[:digit:]]\)| \1|g' && \
	echo '#define bmMACHINE "'`hostname`'"' && \
	echo '#define bmUSER    "'`whoami`'"') > "$(UPPOUT)/build_info.h"

.PHONY: prepare
prepare: \
	$(OutDir_ide) \
	$(OutDir_ide_Common) \
	$(OutDir_ide_Core) \
	$(OutDir_ide_LayDes) \
	$(OutDir_ide_Builders) \
	$(OutDir_ide_Debuggers) \
	$(OutDir_ide_Browser) \
	$(OutDir_CodeEditor) \
	$(OutDir_CtrlLib) \
	$(OutDir_plugin_bz2) \
	$(OutDir_HexView) \
	$(OutDir_TextDiffCtrl) \
	$(OutDir_TabBar) \
	$(OutDir_ide_Designers) \
	$(OutDir_ide_Android) \
	$(OutDir_ide_Java) \
	$(OutDir_ide_MacroManager) \
	$(OutDir_Report) \
	$(OutDir_Core_SSL) \
	$(OutDir_plugin_md) \
	$(OutDir_ide_clang) \
	$(OutDir_Esc) \
	$(OutDir_Core) \
	$(OutDir_plugin_lzma) \
	$(OutDir_plugin_lz4) \
	$(OutDir_plugin_zstd) \
	$(OutDir_RichEdit) \
	$(OutDir_plugin_png) \
	$(OutDir_Draw) \
	$(OutDir_PdfDraw) \
	$(OutDir_Painter) \
	$(OutDir_plugin_pcre) \
	$(OutDir_CtrlCore) \
	$(OutDir_plugin_bmp) \
	$(OutDir_RichText) \
	$(OutDir_ide_IconDes) \
	$(OutDir_plugin_gif) \
	$(OutDir_plugin_jpg)

$(OutFile): build_info  \
	$(OutDir_ide)BaseDlg.o \
	$(OutDir_ide)SelectPkg.o \
	$(OutDir_ide)UppWspc.o \
	$(OutDir_ide)NewPackageFile.o \
	$(OutDir_ide)Organizer.o \
	$(OutDir_ide)Template.o \
	$(OutDir_ide)Console.o \
	$(OutDir_ide)FindFile.o \
	$(OutDir_ide)FindInFiles.o \
	$(OutDir_ide)Config.o \
	$(OutDir_ide)ide.o \
	$(OutDir_ide)idefile.o \
	$(OutDir_ide)EditorTabBar.o \
	$(OutDir_ide)Bottom.o \
	$(OutDir_ide)t.o \
	$(OutDir_ide)AssistDisplay.o \
	$(OutDir_ide)IncludeTrick.o \
	$(OutDir_ide)Assist.o \
	$(OutDir_ide)DCopy.o \
	$(OutDir_ide)ContextGoto.o \
	$(OutDir_ide)GoToLine.o \
	$(OutDir_ide)Swaps.o \
	$(OutDir_ide)Usage.o \
	$(OutDir_ide)ParamInfo.o \
	$(OutDir_ide)Navigator.o \
	$(OutDir_ide)Annotations.o \
	$(OutDir_ide)Virtuals.o \
	$(OutDir_ide)Events.o \
	$(OutDir_ide)NavDlg.o \
	$(OutDir_ide)Log.o \
	$(OutDir_ide)MainConfig.o \
	$(OutDir_ide)Setup.o \
	$(OutDir_ide)Custom.o \
	$(OutDir_ide)Print.o \
	$(OutDir_ide)InsertImage.o \
	$(OutDir_ide)Insert.o \
	$(OutDir_ide)idetool.o \
	$(OutDir_ide)Install.o \
	$(OutDir_ide)Android.o \
	$(OutDir_ide)idebar.o \
	$(OutDir_ide)background.o \
	$(OutDir_ide)idewin.o \
	$(OutDir_ide)main.o \
	$(OutDir_ide)CommandLineHandler.o \
	$(OutDir_ide)About.o \
	$(OutDir_ide)Macro.o \
	$(OutDir_ide)Help.o \
	$(OutDir_ide)SlideShow.o \
	$(OutDir_ide)OnlineSearch.o \
	$(OutDir_ide)Errors.o \
	$(OutDir_ide)Calc.o \
	$(OutDir_ide)FormatCode.o \
	$(OutDir_ide)Abbr.o \
	$(OutDir_ide)Qtf.o \
	$(OutDir_ide)Xml.o \
	$(OutDir_ide)Json.o \
	$(OutDir_ide)MacroManager.o \
	$(OutDir_ide)SetupGIT.o \
	$(OutDir_ide)Upgrade.o \
	$(OutDir_ide)UppHub.o \
	$(OutDir_ide)MethodsCtrls.o \
	$(OutDir_ide)Methods.o \
	$(OutDir_ide)AutoSetup.o \
	$(OutDir_ide)InstantSetup.o \
	$(OutDir_ide)OutputMode.o \
	$(OutDir_ide)Build.o \
	$(OutDir_ide)Debug.o \
	$(OutDir_ide)Valgrind.o \
	$(OutDir_ide)Export.o \
	$(OutDir_ide)RepoConsole.o \
	$(OutDir_ide)RepoSync.o \
	$(OutDir_ide)Credentials.o \
	$(OutDir_ide)Diff.o \
	$(OutDir_ide)DirRepoDiff.o \
	$(OutDir_ide_Common)Common.a \
	$(OutDir_ide_Core)Core.a \
	$(OutDir_ide_LayDes)LayDes.a \
	$(OutDir_ide_Builders)Builders.a \
	$(OutDir_ide_Debuggers)Debuggers.a \
	$(OutDir_ide_Browser)Browser.a \
	$(OutDir_CodeEditor)CodeEditor.a \
	$(OutDir_CtrlLib)CtrlLib.a \
	$(OutDir_plugin_bz2)bz2.a \
	$(OutDir_HexView)HexView.a \
	$(OutDir_TextDiffCtrl)TextDiffCtrl.a \
	$(OutDir_TabBar)TabBar.a \
	$(OutDir_ide_Designers)Designers.a \
	$(OutDir_ide_Android)Android.a \
	$(OutDir_ide_Java)Java.a \
	$(OutDir_ide_MacroManager)MacroManager.a \
	$(OutDir_Report)Report.a \
	$(OutDir_Core_SSL)SSL.o \
	$(OutDir_Core_SSL)SSL.a \
	$(OutDir_plugin_md)md.a \
	$(OutDir_ide_clang)clang.a \
	$(OutDir_Esc)Esc.a \
	$(OutDir_Core)Core.a \
	$(OutDir_plugin_lzma)lzma.a \
	$(OutDir_plugin_lz4)lz4.a \
	$(OutDir_plugin_zstd)zstd.a \
	$(OutDir_RichEdit)RichEdit.a \
	$(OutDir_plugin_png)pngreg.o \
	$(OutDir_plugin_png)png.a \
	$(OutDir_Draw)Draw.a \
	$(OutDir_PdfDraw)PdfInit.o \
	$(OutDir_PdfDraw)PdfDraw.a \
	$(OutDir_Painter)PainterInit.o \
	$(OutDir_Painter)Painter.a \
	$(OutDir_plugin_pcre)pcre.a \
	$(OutDir_CtrlCore)CtrlCore.a \
	$(OutDir_plugin_bmp)BmpReg.o \
	$(OutDir_plugin_bmp)bmp.a \
	$(OutDir_RichText)RichText.a \
	$(OutDir_ide_IconDes)IconDes.a \
	$(OutDir_plugin_gif)gif.o \
	$(OutDir_plugin_gif)gif.a \
	$(OutDir_plugin_jpg)jpgreg.o \
	$(OutDir_plugin_jpg)jpg.a
	$(LINKER) -o "$(OutFile)" -Wl,-s $(LIBPATH) -Wl,-O,2 $(LDFLAGS) -Wl,--start-group  \
		$(OutDir_ide)BaseDlg.o \
		$(OutDir_ide)SelectPkg.o \
		$(OutDir_ide)UppWspc.o \
		$(OutDir_ide)NewPackageFile.o \
		$(OutDir_ide)Organizer.o \
		$(OutDir_ide)Template.o \
		$(OutDir_ide)Console.o \
		$(OutDir_ide)FindFile.o \
		$(OutDir_ide)FindInFiles.o \
		$(OutDir_ide)Config.o \
		$(OutDir_ide)ide.o \
		$(OutDir_ide)idefile.o \
		$(OutDir_ide)EditorTabBar.o \
		$(OutDir_ide)Bottom.o \
		$(OutDir_ide)t.o \
		$(OutDir_ide)AssistDisplay.o \
		$(OutDir_ide)IncludeTrick.o \
		$(OutDir_ide)Assist.o \
		$(OutDir_ide)DCopy.o \
		$(OutDir_ide)ContextGoto.o \
		$(OutDir_ide)GoToLine.o \
		$(OutDir_ide)Swaps.o \
		$(OutDir_ide)Usage.o \
		$(OutDir_ide)ParamInfo.o \
		$(OutDir_ide)Navigator.o \
		$(OutDir_ide)Annotations.o \
		$(OutDir_ide)Virtuals.o \
		$(OutDir_ide)Events.o \
		$(OutDir_ide)NavDlg.o \
		$(OutDir_ide)Log.o \
		$(OutDir_ide)MainConfig.o \
		$(OutDir_ide)Setup.o \
		$(OutDir_ide)Custom.o \
		$(OutDir_ide)Print.o \
		$(OutDir_ide)InsertImage.o \
		$(OutDir_ide)Insert.o \
		$(OutDir_ide)idetool.o \
		$(OutDir_ide)Install.o \
		$(OutDir_ide)Android.o \
		$(OutDir_ide)idebar.o \
		$(OutDir_ide)background.o \
		$(OutDir_ide)idewin.o \
		$(OutDir_ide)main.o \
		$(OutDir_ide)CommandLineHandler.o \
		$(OutDir_ide)About.o \
		$(OutDir_ide)Macro.o \
		$(OutDir_ide)Help.o \
		$(OutDir_ide)SlideShow.o \
		$(OutDir_ide)OnlineSearch.o \
		$(OutDir_ide)Errors.o \
		$(OutDir_ide)Calc.o \
		$(OutDir_ide)FormatCode.o \
		$(OutDir_ide)Abbr.o \
		$(OutDir_ide)Qtf.o \
		$(OutDir_ide)Xml.o \
		$(OutDir_ide)Json.o \
		$(OutDir_ide)MacroManager.o \
		$(OutDir_ide)SetupGIT.o \
		$(OutDir_ide)Upgrade.o \
		$(OutDir_ide)UppHub.o \
		$(OutDir_ide)MethodsCtrls.o \
		$(OutDir_ide)Methods.o \
		$(OutDir_ide)AutoSetup.o \
		$(OutDir_ide)InstantSetup.o \
		$(OutDir_ide)OutputMode.o \
		$(OutDir_ide)Build.o \
		$(OutDir_ide)Debug.o \
		$(OutDir_ide)Valgrind.o \
		$(OutDir_ide)Export.o \
		$(OutDir_ide)RepoConsole.o \
		$(OutDir_ide)RepoSync.o \
		$(OutDir_ide)Credentials.o \
		$(OutDir_ide)Diff.o \
		$(OutDir_ide)DirRepoDiff.o \
			$(OutDir_ide_Common)Common.a \
			$(OutDir_ide_Core)Core.a \
			$(OutDir_ide_LayDes)LayDes.a \
			$(OutDir_ide_Builders)Builders.a \
			$(OutDir_ide_Debuggers)Debuggers.a \
			$(OutDir_ide_Browser)Browser.a \
			$(OutDir_CodeEditor)CodeEditor.a \
			$(OutDir_CtrlLib)CtrlLib.a \
			$(OutDir_plugin_bz2)bz2.a \
			$(OutDir_HexView)HexView.a \
			$(OutDir_TextDiffCtrl)TextDiffCtrl.a \
			$(OutDir_TabBar)TabBar.a \
			$(OutDir_ide_Designers)Designers.a \
			$(OutDir_ide_Android)Android.a \
			$(OutDir_ide_Java)Java.a \
			$(OutDir_ide_MacroManager)MacroManager.a \
			$(OutDir_Report)Report.a \

=== uppbox/Scripts/Makefile ===
.PHONY: all umk ide install clean distclean
SHELL = /bin/sh

all:
	+./domake

umk:
	+./domake umk

ide:
	+./domake ide

install:
	+./doinstall --verbose

uninstall:
	+./douninstall

clean:
	if [ -d "$(UPPOUT)" ] ; then \
		rm -fr "$(UPPOUT)" ; \
	else \
		rm -fr uppsrc/_out ; \
	fi
	rm -f uppsrc/ide.out
	rm -f uppsrc/umk.out

distclean: clean
	rm -f theide
	rm -f umk
	rm -f theide.desktop
	rm -f uppsrc/Makefile
	rm -f uppsrc/uMakefile
	rm -f uppsrc/build_info.h

=== uppbox/lpbuild/Makefile ===
########################################################################
#     __  __  __   ____  __  __  __   __  ____  ___     _      _       #
#    (  )(  )(  ) (_  _)(  )(  \/  ) (  )(_  _)(  _)  _( )_  _( )_     #
#     )(__)(  )(__  )(   )(  )    (  /__\  )(   ) _) (_   _)(_   _)    #
#     \____/ (____)(__) (__)(_/\/\_)(_)(_)(__) (___)   (_)    (_)      #
#        ___  ___    __   __  __  ___  _    _  __   ___   _  _         #
#       (  _)(  ,)  (  ) (  \/  )(  _)( \/\/ )/  \ (  ,) ( )/ )        #
#        ) _) )  \  /__\  )    (  ) _) \    /( () ) )  \  )  \         #
#       (_)  (_)\_)(_)(_)(_/\/\_)(___)  \/\/  \__/ (_)\_)(_)\_)        #
#              __  __   __   _  _  ___  ___  __  __    ___             #
#             (  \/  ) (  ) ( )/ )(  _)(  _)(  )(  )  (  _)            #
#              )    (  /__\  )  \  ) _) ) _) )(  )(__  ) _)            #
#             (_/\/\_)(_)(_)(_)\_)(___)(_)  (__)(____)(___)            #
#                                                                      #
########################################################################

############################## USAGE ###################################
# This makefile is controlled through a set of variables, similar to   #
# any other makefile. The prefered way to change them is via command   #
# line, e.g.: make "PKG=ide usvn" CC=g++                               #
#                                                                      #
# All of the variables that can control the bahaviour are listed below #
# in DEFAULTS section. Also their default value is shown here.         #
#                                                                      #
# For boolean type of variables, values of y, Y, yes, YES, Yes, true,  #
# True, TRUE, T, t, 1, on, On, ON and @ are considered true. Anything  #
# else is evaluated as false.                                          #
############################# TARGETS ##################################
# This makefile defines four targets that are meant to be used by user #
# from the command line:                                               #
#                                                                      #
# all    - builds all (default if any packages are selected)           #
# help   - shows this help (default if no packages are selected)       #
# clean  - deletes OBJDIR                                              #
# export - exports preparsed Makefile to file EXPORT                   #
############################# EXAMPLES #################################
# Typical usage:                                                       #
#    make PKG=ide FLAGS="GUI MT"                                       #
# More complicated usage:                                              #
#    make PKG="ide UWord Bombs" FLAGS="GUI GCC NOGTK" VERBOSE=y        #
# Building "theide" instead of "ide":                                  #
#    make PKG=ide BINPREFIX=bin/the                                    #
# Export makefile with full dependencies:                              #
#    make export PKG=ide FAST=n                                        #
# Show help:                                                           #
#    make OR make help                                                 #
# Simulation mode:                                                     #
#    make PKG=ide SIMULATE=y                                           #
# Silent mode:                                                         #
#    make PKG=ide SILENT=y                                             #
# Paralel compilation (3 paralel processes):                           #
#    make PKG=ide JOBS=3                                               #
############################# DEFAULTS #################################
# List of packages to build (space separated).                         #
# If empty, this help text will be shown.                              #
PKG=
# Paths where to look for packages.                                    #
NESTS=bazaar examples reference tutorial uppsrc
# Flags as in TheIDE.
# The only difference is, that if you use SPEED or SIZE flag, then     #
# the application will be optimized for Speed or Size, respectively.   #
# Flags STATIC and ALLSHARED will determine the linking mode.          #
FLAGS=GCC
# Additional include paths for compiler (without  leading "-I").       #
INCPATHS:=
# Paths to libraries for linker.                                       #
LIBPATHS:=
# Directory to store intermediate object files                         #
OBJDIR:= _out
# Extension added to resulting executables                             #
BINEXT:=
# Prefix for resulting binaries. Usually used with "/" at the end,     #
# to specify the directory (hence the name)                            #
BINPREFIX:=bin/
# ar command                                                           #
AR:= ar -src
# C compiler command                                                   #
CC:= c++
# C++ compiler command                                                 #
CXX:=$(CC)
# Options for C compiler                                               #
CFLAGS:=
# Options for C++ compiler                                             #
CXXFLAGS:=
# Options for linker                                                   #
LDFLAGS:=-Wl,--gc-sections -Wl,-s -Wl,-O,2
# Additional options for speed optimization                            #
SPEEDFLAGS:=-O3 -ffunction-sections -fdata-sections
# Additional options for size optimization                             #
SIZEFLAGS:=-Os -finline-limit=20 -ffunction-sections -fdata-sections
# Platform flag, added to FLAGS                                        #
PLATFORM:=$(shell uname | tr a-z A-Z) POSIX
# Suppress all messagges                                               #
SILENT:=
# Print each executed command                                          #
VERBOSE:=
# Print each executed command, prepended with "SIMULATE: ", without    #
# actually executing it.                                               #
SIMULATE:=
# Do not make full dependency scan (using gcc -M switch).              #
# This saves a lot of time and usually doesn't make any harm.          #
# FAST mode must by turned on only if you modified include files (*.h, #
# *.lay, ...) without modifying the *.c/cpp files that include them.   # 
FAST:=y
# Add flags from based on mainconfig section (not implemented yet)     #
USEMAINCFG:=
# Number of parallel jobs to use (like "make -jN" option).             #
# The JOBS variable must be used instead of -j option (as -j would not #
# work as expected). Default value is the number of cores (if it is    #
# possible to detect) or 1.                                            #
JOBS:=$(shell echo /sys/devices/system/cpu/cpu[0-9] | wc -w || echo 1)
# External parser to use instead of the contained one. Also used       #
# for manipulation with the internal parser (see update-parser,        #
# and export-parser targets in this Makefile for details).             #
PARSER:=
# Exported makefile (used only with export target)                     #
# If multiple packages are being exported, each produces additional    #
# Makefile, which name is EXPORT.package_name                          #
EXPORT:=Makefile.export
# Awk binary. Used only for export.                                    #
AWK:=awk
########################################################################
# HELP END

ifeq ($(filter 3.8%, $(MAKE_VERSION)), )
$(error This Makefile only supports GNU make version 3.80 and newer)
endif

# no need to parse dependencies just to clean up or to read help etc.
ifeq ($(MAKECMDGOALS),clean)
skip-parse:=y
endif
ifeq ($(MAKECMDGOALS),help)
skip-parse:=y
endif
ifeq ($(MAKECMDGOALS),export)
skip-parse:=y
endif
ifeq ($(PKG),)
skip-parse:=y
endif

# Determine the name of this Makefile
filename:=$(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))

# Helper functions to put variables on cmdline
pass-var= "$1=$$($1)"
export-var= "$1=$($1)"
# list of user variables to pass to child processes
cmdline-vars=NESTS FLAGS INCPATHS LIBPATHS OBJDIR BINEXT BINPREFIX AR CC CXX\
 CFLAGS CXXFLAGS LDFLAGS SPEEDFLAGS SIZEFLAGS PLATFORM\
 SILENT VERBOSE SIMULATE FAST USEMAINCFG
L:=(
R:=)
CONFIRM=y Y yes YES Yes true True T TRUE t 1 on On ON @
confirm=$(filter $(strip $1),$(CONFIRM))
# verbose/silent/fast mode switches
S:=$(call confirm,$(SILENT))
M:=$(if $(call confirm,$(VERBOSE)),,@)
M:=$(if $(call confirm,$(SIMULATE)),@echo SIMULATE: ,$M)
F:=$(call confirm,$(FAST))
# echo a string if silent mode is not on
echo=$(if $S,,@echo $1)

ifneq ($(skip-parse),y)

flags:=$(sort $(FLAGS) $(PLATFORM))
CINC:=$(foreach d,$(NESTS) $(INCPATHS), -I$d) -I/usr/include/freetype2 -I/usr/include/gtk-2.0 -I/usr/local/include/gtk-2.0 -I/usr/include/glib-2.0 -I/usr/local/include/glib-2.0 -I/usr/lib/glib-2.0/include -I/usr/local/lib/glib-2.0/include -I/usr/lib/gtk-2.0/include -I/usr/local/lib/gtk-2.0/include -I/usr/include/cairo -I/usr/include/pango-1.0 -I/usr/include/atk-1.0 -I/usr/X11R6/include -I/usr/X11R6/include/freetype2 -I/usr/X11R6/include/gtk-2.0 -I/usr/X11R6/include/glib-2.0 -I/usr/X11R6/lib/glib-2.0/include -I/usr/X11R6/lib/gtk-2.0/include -I/usr/X11R6/include/cairo -I/usr/X11R6/include/pango-1.0 -I/usr/X11R6/include/atk-1.0 -I/usr/local/include/cairo -I/usr/local/include/pango-1.0 -I/usr/local/include/atk-1.0 -I/usr/local/include -I/usr/local/include/libpng -I/usr/include/gdk-pixbuf-2.0 -I/usr/lib/i386-linux-gnu/glib-2.0/include -I/usr/lib/x86_64-linux-gnu/glib-2.0/include -I/usr/lib/i386-linux-gnu/gtk-2.0/include -I/usr/lib/x86_64-linux-gnu/gtk-2.0/include -I/usr/include/gtk-3.0/gdk
LIBPATH:=$(foreach d,$(LIBPATHS), -L$d) -L/usr/X11R6/lib -L/usr/lib -L/usr/local/lib
needed-dirs:=
begin-group:=-Wl,--start-group
end-group:=-Wl,--end-group
# MacOsX specific things
ifeq ($(filter $(PLATFORM),DARWIN),DARWIN)
begin-group:=
end-group:=
endif
# Return true, if package $2 is to be compiled with flag $1
has-flag=$(filter $1,$2)
#Join array with "_"
concatenate=$(strip $(if $1,$(if $(filter $(words $1),1),$1,\
     $(firstword $1)_$(call concatenate,$(wordlist 2,$(words $1),$1)))))
# Return output directory for .o files, based on pkg name and flags
objdir=$(OBJDIR)/$1/$(call concatenate,$($1_FLAGS))
# prepare output directories targets
define create-dir
needed-dirs+= $1
$1:
	$(call echo,"    Creating directory $1 ...")
	$Mmkdir -p $1
endef
needs-dir=$(if $(filter $(needed-dirs),$1),,$(eval $(call create-dir,$1))) $1
# get dependencies recursively
get-deps=$(strip $(foreach p,$($1_USES),$(call get-deps,$p)) $1)

# Compiler commands
compiler-cpp=$(CXX) -c -x c++ $(CXXFLAGS)
compiler-c=$(CC) -c -x c $(CFLAGS)
analyze-info=$(if $S,,    Analyzing $1 dependencies ...)
includes-fetcher-c=$(info $(analyze-info))$(CC) -M -x c $(CXXFLAGS)
includes-fetcher-cpp=$(info $(analyze-info))$(CC) -M -x c++ $(CFLAGS)

# file counting utilities for progress reports
C:=$(OBJDIR)/.make_counter
incrementor:=while ! ln -s -T '$C' '$C_lock' 2>/dev/null;do true; done; echo -n $$$$(($$$$(cat '$C')+1))>'$C';cat '$C'; rm $C_lock;
counter-beg:=c=0; for f in 
counter-end:=; do [ -e $$f ] && c=$$(($$c+1)); done; echo $$c;

# general target scheme (args:{deps,target,pkg,lang,flags}
define compile
$2: $(if $F,$($3_NEST)/$1,$(dir $2)$(shell $(includes-fetcher-$4) $5 $(CINC) $($3_MACRO) $($3_NEST)/$1 |tr -d '\\\\' | sed 's/^[^:]*://')) | $(call needs-dir,$(dir $2))
	$(call echo,"    Compiling $1 $Lflags $(strip $($3_FLAGS))$R ["`$(incrementor)`"/$(file-num)] ...") 
	$M$(compiler-$4) $5 $(CINC) $($3_MACRO) $($3_NEST)/$1 -o $2
$(EMPTYLINE)
endef

#compile .cpp/.c/.icpp into .o/.io
compile-cpp=$(call compile,$1,$2,$3,cpp,)
compile-c=$(call compile,$1,$2,$3,c,)
compile-icpp=$(call compile,$1,$2,$3,cpp,)
# ditto with speed optimization
compile-cpp-speed=$(call compile,$1,$2,$3,cpp,$(SPEEDFLAGS))
compile-c-speed=$(call compile,$1,$2,$3,c,$(SPEEDFLAGS))
compile-icpp-speed=$(call compile,$1,$2,$3,cpp,$(SPEEDFLAGS))

=== uppbox/lpbuild2/Makefile ===
build: ide ide-nogtk umk

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    JOBS:=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
    JOBS:=1
endif

SERIES:="`dpkg-parsechangelog -c1 | sed -n 's/^Distribution: //p;'`"
ARCH:="`dpkg-architecture -qDEB_HOST_ARCH`"
OPTS:=CC="cc -g" CXX="c++ -g" CFLAGS="-g" CXXFLAGS="-g" LDFLAGS="-Wl,--gc-sections -Wl,-O,2" TIME= COLOR=0 USEMAINCFG=0

ide:
	sed -i -e 's/IDE_VERSION[ \t]*"\([0-9]*\)[^"]*"/IDE_VERSION    "\1-'$(SERIES)-$(ARCH)'"/' $(CURDIR)/uppsrc/ide/version.h
	export CCACHE_DISABLE=1; $(MAKE) -f mkfile JOBS=$(JOBS) PKG=ide "NESTS=uppsrc" $(OPTS) "FLAGS=GUI GCC DEBUG DEBUG_FULL STACKTRACE" TARGET=`pwd`/$@

ide-nogtk:
	sed -i -e 's/IDE_VERSION[ \t]*"\([0-9]*\)[^"]*"/IDE_VERSION    "\1-'$(SERIES)-$(ARCH)'-nogtk"/' $(CURDIR)/uppsrc/ide/version.h
	export CCACHE_DISABLE=1; $(MAKE) -f mkfile JOBS=$(JOBS) PKG=ide "NESTS=uppsrc" $(OPTS) "FLAGS=GUI NOGTK GCC DEBUG DEBUG_FULL STACKTRACE" TARGET=`pwd`/$@

umk:
	export CCACHE_DISABLE=1; $(MAKE) -f mkfile JOBS=$(JOBS) PKG=umk "NESTS=uppsrc" $(OPTS) "FLAGS=GCC DEBUG DEBUG_FULL STACKTRACE" TARGET=`pwd`/$@

install:
	# this is just a trick to rename files
	install -D ide $(DESTDIR)/theide
	install -D ide-nogtk $(DESTDIR)/nogtk/theide
	install -D -m 644 uppsrc/ide/theide-48.png $(DESTDIR)/theide.png

clean:
	rm -f ide ide-nogtk umk

distclean: clean

=== uppbox/lpbuild2/debian/changelog ===
upp (1) any; urgency=low

  * Fake changelog! Only to make uscan work.

 -- Jan Dolinar <dolik.rce@seznam.cz>  Mon, 27 Feb 2012 16:24:38 +0100

=== uppbox/lpbuild2/debian/control ===
Source: upp
Section: devel
Priority: optional
Maintainer: Jan Dolinar <dolik.rce@seznam.cz>
Standards-Version: 3.9.1
Build-Depends: g++ (= 4.1) | g++ (>= 4.3), debhelper (>= 7), libx11-dev (>= 1.0.0), libxft-dev (>= 2.1.8), libpng12-dev (>= 1.2.8), libbz2-dev, libgtk2.0-dev (>= 2.8.17), libnotify-dev
Homepage: http://www.ultimatepp.org

Package: upp
Architecture: all
Depends: theide, ${misc:Depends}, g++ (= 4.1) | g++ (>= 4.3), libx11-dev (>= 1.0.0), libxft-dev (>= 2.1.8), libpng12-dev (>= 1.2.8), libbz2-dev, libgtk2.0-dev (>= 2.8.17), libnotify-dev
Description: C++ library for cross-platform development
 Ultimate++ is a radical and innovative GUI toolkit whose number one priority
 is programmer productivity. C++ is a great programming language but
 C++ programmers are sometimes hampered by the lack of effective libraries.
 U++ libraries enable genuine productivity gains with shorter development
 times and greatly reduced application source code size.

Package: theide
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: sox
Replaces: upp (<= 2332)
Description: IDE (not only) for Ultimate++ framework
 TheIDE introduces modular concepts to C++ programming. It features 
 BLITZ-build technology to speedup C++ rebuilds up to 4 times, Visual 
 designers for U++ libraries, Topic++ system for documenting code 
 and creating rich text resources for applications (like help and code 
 documentation) and Assist++ - a powerful C++ code analyzer that provides 
 features like code completion, navigation and transformation.

Package: theide-nogtk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: sox
Provides: theide
Replaces: theide, upp (<=2332)
Conflicts: theide
Description: IDE (not only) for Ultimate++ framework [nogtk build]
 TheIDE introduces modular concepts to C++ programming. It features 
 BLITZ-build technology to speedup C++ rebuilds up to 4 times, Visual 
 designers for Ultimate++ libraries, Topic++ system for documenting code 
 and creating rich text resources for applications (like help and code 
 documentation) and Assist++ - a powerful C++ code analyzer that provides 
 features like code completion, navigation and transformation.
 .
 This package contains TheIDE built with simpler look to reduce
 package dependencies.

Package: umk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: theide
Replaces: theide, upp (<=2332)
Conflicts: theide
Description: Command line builder for Ultimate++ projects
 For those who need to build U++ packages from scripts or in minimalistic
 environments, umk utility provides simple building solution. It fully supports
 all the build-related features provided by TheIDE, without the actual IDE.

Package: theide-dbg
Architecture: any
Depends: theide (= ${Source-Version})
Section: debug
Priority: extra
Description: Debug symbols for theide package
 Detached debugging symbols for easier debugging of errors in theide itself.

Package: theide-nogtk-dbg
Architecture: any
Depends: theide-nogtk (= ${Source-Version})
Section: debug
Priority: extra
Description: Debug symbols for theide-nogtk package
 Detached debugging symbols for easier debugging of errors in theide itself.

Package: umk-dbg
Architecture: any
Depends: umk (= ${Source-Version})
Section: debug
Priority: extra
Description: Debug symbols for umk package
 Detached debugging symbols for easier debugging of errors in umk tool.

=== uppbox/lpbuild2/debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE=1

override_dh_strip:
	for P in $$(sed -n 's/^Package: \(.*\)-dbg$$/\1/p' debian/control); do \
	  dh_strip -v -p $${P} --dbg-package=$${P}-dbg; \
	done
	dh_strip -v --remaining-packages

%:
	dh $@ -v

=== uppbox/lpbuild2/debian/watch ===
version=3

# nightly builds
http://ultimatepp.org/downloads/upp-x11-src-(.*)\.tar\.gz

# stable release
#http://sf.net/upp/upp-x11-src-(.*)\.tar\.gz
